<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' products handling routines
'*********************************************************************************

function ShopFormatCurrency (amount, decimalpoint)
   '701 - 2011.01.31 - should truncate the order amount to match with the calculation
   if trim(amount) <> "" and isnull(amount) = false then 
      '701 - 2011.03.07 - Bug Fix: if amount using comma regional
	  '701 - 2011.06.10 - Bug Fix: Tax is wrongly calculated if less than 0.1
	  if cdbl(amount) >= 1 then
	     if instr(formatcurrency(100,2),",") <= 0 then amount = cdbl(rounddown(amount,decimalpoint))
	  else
	     if instr(formatcurrency(100,2),",") <= 0 then amount = formatNumber (amount, decimalpoint)
	  end if
	  
	  if trim(amount) = "" then amount = 0
   end if

   ' Handle 0 and garbage prices
   dim tamount
   tamount = amount
   if GetSess("Fullunitname")<>"" then
      tamount = Currencypriceconvert(tamount)
   end if
   if not isnumeric(tamount) then
      tamount = 0
   end if
   if tamount = 0 then
      if GetConfig("xprice0")<>"" then
         ShopFormatCurrency = GetConfig("xprice0")
         exit function
      end if
   end if
   if GetSess("Newcurrencysymbol")<>"" then
      ShopFormatCurrency = GetSess("Newcurrencysymbol") & formatnumber (tamount, decimalpoint)
   elseif GetConfig("XCurrencySymbol") <> "" then
      ShopFormatCurrency = GetConfig("XCurrencySymbol") & formatnumber (tamount, decimalpoint)
   else
      ShopFormatCurrency = "$" & formatnumber (tamount, decimalpoint)
   end if
end function

'VP-ASP 600 formats dual currency
'12/10/2005
function ShopFormatDualCurrency (amount, decimalpoint)
   if GetConfig("xdualcurrencysymbol")<>"" then
      shopformatdualcurrency = GetConfig("xdualcurrencysymbol") & formatnumber (amount, decimalpoint)
   else
      shopformatdualcurrency = formatcurrency (amount, decimalpoint)

   end if
end function

sub RestoreCurrency
   on error resume next
   dim restored
   dim PricesIncVAT
   restored = GetSess("Restored")
   if restored<>"" then exit sub
   'Restore currency information
   if Request.Cookies("Currency") <> "" then
      call SetCurrency(Request.Cookies("Currency")("CID"), Request.Cookies("Currency")("IncVAT"))
   else
      if GetConfig("xtaxincludedinprice") = "Yes" then
         PricesIncVAT = True
      else
         PricesIncVAT = False
      end if
      call SetCurrency(GetConfig("xcurrencybase"), PricesIncVAT)
   end if
   SetSess "restored", "Yes"
end sub

'So if a cookie is found we take the id and if the users want VAT or not otherwise we get two config values, first is the standard xtaxincludedinprice to decide if we should add VAT and the other is a new one, XDefaultCurrency, a config value to use when no setting is found.
'Setting the currency is done by a function SetCurrency which I put in Shop$DB very straight forward, you can see it appears in both routines above.
sub SetCurrency(ByVal CurrencyID, ByVal VAT)
   dim CurrName, CurrRate, CurrSymbol, DefaultVAT
   'Get the currency data
   call GetCurrData(CurrencyID, CurrName, CurrRate, CurrSymbol)
   'If no rows are returned, get the xDefaultCurrency data
   if CurrName = "" then call GetCurrData(GetConfig("xcurrencybase"), CurrName, CurrRate, CurrSymbol)
   'Set up the Session Variables
   SetSess "CID", CurrencyID
   SetSess "Fullunitname", CurrName
   SetSess "Conversionvalue", CurrRate
   SetSess "Newcurrencysymbol", CurrSymbol
   SetSess "IncVAT", cbool(VAT)

   'Write a Cookie with the Currency ID & VAT Status.
   Response.cookies("Currency")("CID") = CurrencyID
   Response.cookies("Currency")("IncVAT") = VAT
   Response.Cookies("Currency").Expires = date + 10
end sub


'One last sub, GetCurrData which just pulls the currency from a new currency table.
sub GetCurrData(CurrID, CurrName, CurrRate, CurrSymbol)
   if CurrID = "" then exit sub
   dim sql, rs
   '700 - 2010.05.24 - Enhancement: MsSQL with double bytes (utf8) issues
   sql = "select * from currencyvalues where cid = "& sqlserverprefixn &"'" & currid & "'"
   Set rs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   '701 - 2011.03.15 - Enhancement: Speed up store performance
   rs.open sql, dbc, adOpenForwardOnly, adLockReadOnly
   if not rs.eof then
      currname = rs("fullunitname")
      currrate = rs("conversionvalue")
      currsymbol = rs("currencysymbol")
   end if
   CloseRecordSet rs
end sub

function Currencypriceconvert(price)
   '700 - 2010.08.16 - Bug Fix: Possible error if restoring saved-cart
   if isnull(price) then price = 0
   if trim(price) = "" then price = 0
   if isnumeric(price) = false then price = 0
   on error resume next
   
   '6.09 - fix if there is no conversion value, then don't modify the price
   if GetSess("Conversionvalue") = "" or isnull(GetSess("Conversionvalue")) then
      Currencypriceconvert = price
   else
      '700 - 2010.08.16 - Bug Fix: Possible error if restoring saved-cart
      Currencypriceconvert = cdbl(price) * GetSess("Conversionvalue")
   end if

   '700 - 2010.08.16 - Bug Fix: Possible error if restoring saved-cart
   if err.number <> 0 then
	  price = 0
	  Currencypriceconvert = 0
	  err.clear
   end if
end function

sub navigateshowcurrency
   if GetSess("Fullunitname")<>"" then
      HtmlWrite "<span class=""loginlink"">Chosen Currency<br />"
      HtmlWrite "" & GetSess("Fullunitname") & "</span>"
   end if
   'HtmlWrite "<span class=""loginlink""><a href=""shopcurrency.asp"">Change Currency</a></span>"
end sub

sub Navigateshowcurrencies (prefix)
   SetSess "ReturnURL", request.ServerVariables("scriptname")
   SetSess "ReturnURL", right(GetSess("ReturnURL"), instrrev(GetSess("ReturnURL"), "/"))
   dim rs, sql, cid, checked
%>
<form name="<%=prefix%>CurrencyForm" id="<%=prefix%>CurrencyForm" action="#">
<select name="menu" onchange = "self.location = document.<%=prefix%>CurrencyForm.menu[document.<%=prefix%>CurrencyForm.menu.selectedIndex].value;" class="txtfielddropdown" size="1">
<%
   sql = "select cid,fullunitname from currencyvalues where hide = 0 order by fullunitname"
   Set rs = Server.CreateObject("ADODB.Recordset")
   '700 - 2010.09.26 - Enhancement: Speed up front store performance
   '701 - 2011.03.15 - Enhancement: Speed up store performance
   rs.open sql, dbc, adOpenForwardOnly, adLockReadOnly
   do while not rs.eof
      cid = rs("cid")
      if cid = GetSess("cid") then
         checked = " selected=""selected"""
      else
         checked = ""
      end if

      '6.50 - added call to redirect to shopcurrency.asp
      HtmlWrite "<option value="""& xmysite2 &"/shopcurrency.asp?CID=" &rs("cid") & "&amp;goback=yes""" & checked & ">" & rs("fullunitname")& "</option>" & vbcrlf
      rs.MoveNext
   loop
   HtmlWrite "</select></form>"
   CloseRecordSet rs
end sub

' Used when return a currency with currrebcy symbol
function ShopFormatCurrencyNumber (amount, decimalpoint)
   ' Handle 0 and garbage prices
   dim tamount
   tamount = amount
   if GetSess("Fullunitname")<>"" then
      tamount = Currencypriceconvert(tamount)
   end if
   if not isnumeric(tamount) then
      tamount = 0
   end if
   if tamount = 0 then
      if GetConfig("xprice0")<>"" then
         ShopFormatCurrency = GetConfig("xprice0")
         exit function
      end if
   end if
   ShopFormatCurrencynumber = formatnumber (tamount, decimalpoint)
end function

'701 - 2011.01.31 - should truncate the order amount to match with the calculation
'701 - 2011.03.07 - Bug Fix: if amount using comma regional
function RoundDown(value,decimal)
   if trim(value) = "" or isnull(value) then
      rounddown = ""
	  exit function
   end if
   
   dim negativeflag
   negativeflag = false
   if value < 0 then
      negativeflag = true
	  value = -(value)
   end if
   
   dim decimalsymbol
   decimalsymbol = "."
   if instr(formatcurrency(100,2),",") > 0 then decimalsymbol = ","
   
   '701 - 2011.11.11 - Bug Fix: if amount using comma regional but pass in dot value, that will return wrong decimal amount
   if instr(value,".") > 0 then decimalsymbol = "."
   
   dim startchar,displayzero,k,i
   startchar = instr(value,decimalsymbol)
   displayzero = ""
   if startchar = 0 then
      for i = 1 to decimal
	     displayzero = displayzero & "0"
	  next
	  if negativeflag then
	     RoundDown = -(int(value) & decimalsymbol & displayzero)
	  else
         RoundDown = int(value) & decimalsymbol & displayzero
	  end if
   else
      k = len(value) - startchar
      if k < decimal then
	     for i = 1 to (decimal - k)
		    displayzero = displayzero & "0"
		 next
	  end if
      startchar = startchar + 1
	  if negativeflag then
	     RoundDown = -(int(value) & decimalsymbol & mid(cstr(value),startchar, decimal) & displayzero)
	  else
         RoundDown = int(value) & decimalsymbol & mid(cstr(value),startchar, decimal) & displayzero
	  end if
   end if
end function
%>